import { IOPosInvoke } from "./definitions/IOPosInvoke";
import { AppEnablement } from "./AppEnablement";
interface IEventMap {
    [key: string]: Array<IRegisteredEvent>;
}
interface WindowAsAny extends Window {
    [index: string]: any;
}
interface IRegisteredEvent {
    callback: (data: any) => void;
    globalId: string;
}
export declare class OPosProvider extends AppEnablement {
    eventCallbacks: IEventMap;
    windowAsAny: WindowAsAny;
    jxBridge: any;
    readonly JX_BRIDGE: string;
    readonly GK_ID_PREFIX = "GK_";
    constructor();
    private registerApis;
    private oposCancellEventRegistration;
    private oposEventRegistration;
    private prepareInvokeString;
    private setWindowHandlers;
    private clearWindowProperties;
    invokeOpos(invocation: IOPosInvoke): void;
}
export {};
