"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OPosPosApi_1 = require("./adapters/OPosPosApi");
var OPosMasterDataApi_1 = require("./adapters/OPosMasterDataApi");
var OPosCommonApi_1 = require("./adapters/OPosCommonApi");
var AppEnablement_1 = require("./AppEnablement");
var OPosExternalMasterDataApi_1 = require("./adapters/OPosExternalMasterDataApi");
var OPosProvider = (function (_super) {
    __extends(OPosProvider, _super);
    function OPosProvider() {
        var _this = _super.call(this) || this;
        _this.windowAsAny = window;
        _this.JX_BRIDGE = "injected_by_POS__postWebAppRequest";
        _this.GK_ID_PREFIX = "GK_";
        _this.jxBridge = _this.windowAsAny[_this.JX_BRIDGE];
        _this.eventCallbacks = {};
        _this.registerApis();
        return _this;
    }
    OPosProvider.prototype.registerApis = function () {
        this.registerApi(new OPosPosApi_1.OPosPosApi(this.invokeOpos.bind(this)));
        this.registerApi(new OPosMasterDataApi_1.OPosMasterDataApi(this.invokeOpos.bind(this)));
        this.registerApi(new OPosExternalMasterDataApi_1.OPosExternalMasterDataApi(this.invokeOpos.bind(this)));
        this.registerApi(new OPosCommonApi_1.OPosCommonApi(this.invokeOpos.bind(this), this.oposEventRegistration.bind(this), this.oposCancellEventRegistration.bind(this)));
    };
    OPosProvider.prototype.oposCancellEventRegistration = function (eventRegistration) {
        var regEventData = {};
        if (this.eventCallbacks.hasOwnProperty(eventRegistration.event)) {
            for (var i = this.eventCallbacks[eventRegistration.event].length - 1; i >= 0; i--) {
                var event_1 = this.eventCallbacks[eventRegistration.event][i];
                if (event_1.globalId === this.GK_ID_PREFIX + eventRegistration.id) {
                    this.clearWindowProperties(event_1.globalId);
                    regEventData = {
                        event: eventRegistration.event,
                        listener: event_1.globalId
                    };
                    this.eventCallbacks[eventRegistration.event].splice(i, 1);
                }
            }
        }
        var request = this.prepareInvokeString(eventRegistration.prefix, "unregisterListener", "", regEventData);
        this.jxBridge.invoke(request);
    };
    OPosProvider.prototype.oposEventRegistration = function (eventRegistration) {
        var globalId = this.GK_ID_PREFIX + eventRegistration.id;
        var eventCallback = {
            callback: eventRegistration.listener,
            globalId: globalId
        };
        if (this.eventCallbacks.hasOwnProperty(eventRegistration.event)) {
            this.eventCallbacks[eventRegistration.event].push(eventCallback);
        }
        else {
            this.eventCallbacks[eventRegistration.event] = new Array(eventCallback);
        }
        this.setWindowHandlers(globalId, eventRegistration.listener, false);
        var regEventData = {
            event: eventRegistration.event,
            listener: globalId,
            passData: eventRegistration.passData
        };
        var request = this.prepareInvokeString(eventRegistration.prefix, "registerListener", "", regEventData);
        this.jxBridge.invoke(request);
    };
    OPosProvider.prototype.prepareInvokeString = function (prefix, method, callbackStamp, data) {
        var invoke = "jmc://" + prefix + method + "?";
        var success = "onResult=" + callbackStamp;
        var error = "onError=" + callbackStamp;
        var request = "" + invoke + success + "&" + error;
        if (data) {
            if (typeof data === 'string') {
                request = request + "&0=" + encodeURIComponent(data);
            }
            else if (typeof data === 'object') {
                request = request + "&0=" + encodeURIComponent(JSON.stringify(data));
            }
        }
        return request;
    };
    OPosProvider.prototype.setWindowHandlers = function (globalId, callback, autoClear) {
        var _this = this;
        if (autoClear === void 0) { autoClear = true; }
        var regCallback = "" + globalId;
        this.windowAsAny[regCallback] = function (data) {
            if (autoClear) {
                _this.clearWindowProperties(regCallback);
            }
            callback(data);
        };
    };
    OPosProvider.prototype.clearWindowProperties = function (callbackName) {
        this.windowAsAny[callbackName] = undefined;
        delete (this.windowAsAny[callbackName]);
    };
    OPosProvider.prototype.invokeOpos = function (invocation) {
        var callTimestamp = this.GK_ID_PREFIX + new Date().getTime();
        if (invocation.callback) {
            this.setWindowHandlers(callTimestamp, invocation.callback);
        }
        var request = this.prepareInvokeString(invocation.prefix, invocation.method, callTimestamp, invocation.data);
        this.jxBridge.invoke(request);
    };
    return OPosProvider;
}(AppEnablement_1.AppEnablement));
exports.OPosProvider = OPosProvider;
